#include <stdio.h>
#include <stdint.h>

static uint32_t expm(uint32_t pow) {
	return 2 << pow;
}

static uint32_t sum_bin_digits(uint32_t n) {
	uint32_t sum = 0;
	for (uint32_t i = 0; i < 32; i++) {
		sum += (n & 1);
		n = n >> 1;
	}
	return sum;
}

int32_t main() {
	uint32_t N, K;
	uint32_t a = 0;
	scanf("%u %u\n", &N, &K);
	for (uint32_t i = 0; i < N; i++) {
		const char x = getchar();
		a |= (x == '1');
		a = a << 1;
	}
	a = a >> 1;

	// printf("N=%u, K=%u, a=%u\n", N, K, a);

	const uint32_t mod = expm(N-1) - 1;
	uint32_t count = 0;

	for (uint32_t b = 0; b < expm(N-1); b++) {
		// if (sum_bin_digits((a+b)&mod) == K)
		// 	printf("%u\n", (a+b)&mod);
		count += (sum_bin_digits((a+b)&mod) == K);
	}

	printf("%u\n", count);
}
